/* CG/solution/parts/cgp11.c */

/****************************************************************
 *                                                              *
 * This file has been written as a sample solution to an        *
 * exercise in a course given at the High Performance           *
 * Computing Centre Stuttgart (HLRS).                           *
 * It is made freely available with the understanding that      *
 * every copy of this file must include this header and that    *
 * HLRS takes no responsibility for the use of the enclosed     *
 * teaching material.                                           *
 *                                                              *
 * This software is partitioned into 16 tasks.                  *
 * Each task can be implemented by one group of the course      *
 * Files: CG/solution/cg_all.c - Solution                       *
 *        CG/skel/cg_01.c      - Skeletons that should be used  *
 *             .. cg_15.c        to implement each task         *
 *        CG/solution/cgp00.c  - Source part of each task       *
 *             ..     cgp16.c                                   *
 *                                                              *
 * Authors: Dr. Rolf Rabenseifner                               *
 *          Felix Triebel                                       *
 *          Michael Speck                                       *
 *          Felix Triebel                                       *
 *          Traugott Streicher                                  *
 *                                                              *
 * Contact: rabenseifner@hlrs.de                                *
 *                                                              *
 ****************************************************************/
                                                           /*EOH*/
/*>>>>>>>>>>>>>>>>>>>>>> begin of task 11 <<<<<<<<<<<<<<<<<<<<<<*/

/************************ application *************************/

/*------------------------------
 * void Init_Laplace_A
 *  IN/OUT struct matrix_chunk * A : the local chunk of matrix A
 *
 * TASK: go through the local chunk of matrix A,
 *       allocate each matrix row and set it's values
 *
 * REFERENCE: Slides 28, 24
 *
 * GLOBAL DATA:
 *  IN int start : begin of the local chunk
 *  IN int end1  : end+1 of the local chunk
 * USED FUNCTIONS: APPL: Alloc_Matrix_Row, I2ij, ij2I, Mat_Set_Value
 */
void Init_Laplace_A(struct matrix_chunk *A)
{
        int I, J, i, j;

        for (I=start; I<end1; I++) {
                Alloc_Matrix_Row(A, I, 5 /* not more than 5 values on next lines*/);
                I2ij(I, &i, &j);
                if (i>0)   {ij2I(i-1,j,&J); Mat_Set_Value(A,I,J,-1.0);}
                if (j>0)   {ij2I(i,j-1,&J); Mat_Set_Value(A,I,J,-1.0);}
                J = I;                      Mat_Set_Value(A,I,J, 4.0);
                if (j<n-1) {ij2I(i,j+1,&J); Mat_Set_Value(A,I,J,-1.0);}
                if (i<m-1) {ij2I(i+1,j,&J); Mat_Set_Value(A,I,J,-1.0);}
        }
}

/*>>>>>>>>>>>>>>>>>>>>>> -end- of task 11 <<<<<<<<<<<<<<<<<<<<<<*/
