/* CG/solution/parts/cgp13.c */

/****************************************************************
 *                                                              *
 * This file has been written as a sample solution to an        *
 * exercise in a course given at the High Performance           *
 * Computing Centre Stuttgart (HLRS).                           *
 * It is made freely available with the understanding that      *
 * every copy of this file must include this header and that    *
 * HLRS takes no responsibility for the use of the enclosed     *
 * teaching material.                                           *
 *                                                              *
 * This software is partitioned into 16 tasks.                  *
 * Each task can be implemented by one group of the course      *
 * Files: CG/solution/cg_all.c - Solution                       *
 *        CG/skel/cg_01.c      - Skeletons that should be used  *
 *             .. cg_15.c        to implement each task         *
 *        CG/solution/cgp00.c  - Source part of each task       *
 *             ..     cgp16.c                                   *
 *                                                              *
 * Authors: Dr. Rolf Rabenseifner                               *
 *          Felix Triebel                                       *
 *          Michael Speck                                       *
 *          Felix Triebel                                       *
 *          Traugott Streicher                                  *
 *                                                              *
 * Contact: rabenseifner@hlrs.de                                *
 *                                                              *
 ****************************************************************/
                                                           /*EOH*/
/*>>>>>>>>>>>>>>>>>>>>>> begin of task 13 <<<<<<<<<<<<<<<<<<<<<<*/

void appl_print_vec(char *name, double *v, int mprint, int nprint)
{
        int i,j, I;
        if (my_rank == 0)
        {
                printf("%s:       j=",name);
                    for (j=0; j<n; j++)
                            if ((n>nprint ? (nprint-1)*(j+n-2)/(n-1) != (nprint-1)*(j+n-1)/(n-1) : 1))
                                printf(" %5d",j); printf("\n");

                for (i=0; i<m; i++)
                  if ((m>mprint ? (mprint-1)*(i+m-2)/(m-1) != (mprint-1)*(i+m-1)/(m-1) : 1))
                  {
                    printf("%s: i=%3d   ",name,i);
                    for (j=0; j<n; j++)
                    {
                        ij2I(i, j, &I);
                        if ((n>nprint ? (nprint-1)*(j+n-2)/(n-1) != (nprint-1)*(j+n-1)/(n-1) : 1))
                            printf(" %5.3f",v[I]);
                    }
                    printf("\n");
                  }
        }
}

/*>>>>>>>>>>>>>>>>>>>>>> -end- of task 13 <<<<<<<<<<<<<<<<<<<<<<*/
